// V43 checksum calculator

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
    unsigned int checksum = 0;
    FILE *binfp;
    unsigned char buffer[4096] = {0, };
    int i, j;

    if( argc < 2 ) {
        printf("Usage : ./%s <file-to-calculate>\n", argv[0]);
        return -1;
    }

    if( ((binfp = fopen(argv[1], "rb")) == NULL) ) {
        perror("error : cannot open kernel.bin\n");
        return -1;
    }

    memset(buffer, 0, sizeof(buffer));
    while(binfp) {
        i = fread(buffer, 1, sizeof(buffer), binfp);
        if(i == 0) break;

        for(j = 0; j < i; ++j)
            checksum += buffer[j] & 0x00FF;
    }

    fclose(binfp);
    printf("checksum = %08x\n", checksum);
    return 0;
}
